//-------------------------------------------------------------
//  Etasoft Inc. Forex EA and Script Generator version 4.1   EA
//-------------------------------------------------------------
// Keywords: MT4, Forex EA builder, create EA, expert advisor developer

#property copyright "Copyright  2011, Etasoft Inc. Forex EA Generator v4.1"
#property link      "sulaimoney"

#include <stdlib.mqh>
#include <WinUser32.mqh>

// exported variables
extern int OrderId = 1;
extern int Slippage = 2; 
extern double Lots = 0.01;
extern int Grid  = 10;  // total distance in pips to open  orders
extern string EAComment = "464 testing";
extern string HeaderText2 = "LastMktOrderInfo";




// local variables
double PipValue=1;    // this variable is here to support 5-digit brokers
bool Terminated = false;
string LF = "\n";  // use this in custom or utility blocks where you need line feeds
int NDigits = 4;   // used mostly for NormalizeDouble in Flex type blocks
int ObjCount = 0;  // count of all objects created on the chart, allows creation of objects with unique names
int current = 0;

bool Executed6 = false;




int init()
{
    NDigits = Digits;
    
    if (false) ObjectsDeleteAll();      // clear the chart
    
    
    Comment("");    // clear the chart
}

// Expert start
int start()
{
    if (Bars < 10)
    {
        Comment("Not enough bars");
        return (0);
    }
    if (Terminated == true)
    {
        Comment("EA Terminated.");
        return (0);
    }
    
    OnEveryTick1();
    
}

void OnEveryTick1()
{
    if (true == false && false) PipValue = 10;
    if (true && (NDigits == 3 || NDigits == 5)) PipValue = 10;
    
//    IfNoOrderExist5();
//    IfOrderExists6();
    double lastPrice; LastMktOrder(lastPrice);
      PrintFunctionsToChart(lastPrice);
    
    
   
     
    
}
void IfNoOrderExist5()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderSymbol() == Symbol())
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
       ExecuteOnce6();
        
        
    }
}
void ExecuteOnce6()
{
    
    
    
    
    if (Executed6 == false)
    {
        Executed6 = true;
        BuyPendingOrder();
        SellPendingOrder();
        
    }
}


 void BuyPendingOrder()
{
    int expire = TimeCurrent() + 60 * 0;
    double price = NormalizeDouble((Ask-((Ask-Bid)/2)), NDigits) + Grid*PipValue*Point;
    double SL = price - 0*PipValue*Point;
    if (0 == 0) SL = 0;
    double TP = price + 0*PipValue*Point;
    if (0 == 0) TP = 0;
    if (0 == 0) expire = 0;
    int ticket = OrderSend(Symbol(), OP_BUYSTOP, Lots, price,  Slippage, SL, TP, EAComment, OrderId, expire, Blue);
    if (ticket == -1)
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
     
}

void SellPendingOrder()
{
    int expire = TimeCurrent() + 60 * 0;
    double price = NormalizeDouble((Bid+((Ask-Bid)/2)), NDigits) - Grid*PipValue*Point;
    double SL = price + 0*PipValue*Point;
    if (0 == 0) SL = 0;
    double TP = price - 0*PipValue*Point;
    if (0 == 0) TP = 0;
    if (0 == 0) expire = 0;
    int ticket = OrderSend(Symbol(), OP_SELLSTOP, Lots, price, Slippage, SL, TP, EAComment, OrderId, expire, Red);
    if (ticket == -1)
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
    
}


void IfOrderExists6()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
       if (OrderType() == OP_BUY  || OrderType() == OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists)
    {
        
      IfOrderDoesNotExist7();
      IfOrderDoesNotExist5();
            
    }
}

void IfOrderDoesNotExist5()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_BUYSTOP && OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        BuyPendingOrder1();
        
    }
}

void IfOrderDoesNotExist7()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_SELLSTOP && OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
      SellPendingOrder1();    
    }
}

  

 



void BuyPendingOrder1()
{
     
    int expire = TimeCurrent() + 60 * 0;
    double price = NormalizeDouble( Ask, NDigits) + (Grid )*PipValue*Point;
    double SL = price - 0*PipValue*Point;
    if (0 == 0) SL = 0;
    double TP = price + 0*PipValue*Point;
    if (0 == 0) TP = 0;
    if (0 == 0) expire = 0;
    int ticket = OrderSend(Symbol(), OP_BUYSTOP, Lots, price,  Slippage, SL, TP, EAComment, OrderId, expire, Blue);
    if (ticket == -1)
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
    
}


void SellPendingOrder1()
{
   
    int expire = TimeCurrent() + 60 * 0;
    double price = NormalizeDouble( Bid , NDigits) - (Grid )*PipValue*Point;
    double SL = price + 0*PipValue*Point;
    if (0 == 0) SL = 0;
    double TP = price - 0*PipValue*Point;
    if (0 == 0) TP = 0;
    if (0 == 0) expire = 0;
    int ticket = OrderSend(Symbol(), OP_SELLSTOP, Lots, price, Slippage, SL, TP, EAComment, OrderId, expire, Red);
    if (ticket == -1)
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
    
}

void   LastMktOrder(double &lastPrice)
{   
    datetime lastTime  = 0;  
    int      lastTicket = -1; // None open.      
    for (int i=OrdersTotal()-1; i >= 0; i--) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {     
        
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == OrderId 
        && OrderOpenTime() >= lastTime && OrderCloseTime() == 0
        && OrderTicket() > lastTicket && (OrderType() == OP_BUY  || OrderType() == OP_SELL) )
        {          
             lastTime   = OrderOpenTime(); 
             lastPrice = OrderOpenPrice();                      
             lastTicket = OrderTicket();            
             
           
            
        }
        return(lastTicket);
         
      
    }
    else
    Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    
}

void PrintFunctionsToChart(double priceToDisplay)
{
     
    string temp = "HeaderText2\n";
    temp = temp + "------------------------------------------------\n"
    + "Some text " + DoubleToStr(priceToDisplay, 5) + "\n"
    + "Some text " + DoubleToStr(0, 5) + "\n"
    + "Some text " + DoubleToStr(0, 5) + "\n"
    + "Some text " + DoubleToStr(0, 5) + "\n"
    + "------------------------------------------------\n";
    Comment(temp);
    
}




int deinit()
{
    if (false) ObjectsDeleteAll();
    
    
}